Loading...
Searching...
No Matches
casacore::Gaussian3D_PS< AutoDiff< T > > Class Template Reference

Partial specialization of Gaussian3D for AutoDiff. More...

`#include <Gaussian3D.h>`

## Public Member Functions

| Gaussian3D_PS ()
| Gaussian3D_PS (const AutoDiff< T > &height, const Vector< AutoDiff< T > > &center, const Vector< AutoDiff< T > > &width, const AutoDiff< T > &theta, const AutoDiff< T > &phi)
| Gaussian3D_PS (AutoDiff< T > &height, AutoDiff< T > &xCenter, AutoDiff< T > &yCenter, AutoDiff< T > &zCenter, AutoDiff< T > &xWidth, AutoDiff< T > &yWidth, AutoDiff< T > &zWidth, AutoDiff< T > &theta, AutoDiff< T > &phi)
| Gaussian3D_PS (const Gaussian3D_PS< AutoDiff< T > > &other)
template<class W>
| Gaussian3D_PS (const Gaussian3D_PS< W > &other)
virtual | ~Gaussian3D_PS ()
Gaussian3D_PS< AutoDiff< T > > & | operator= (const Gaussian3D_PS< AutoDiff< T > > &other)
virtual AutoDiff< T > | eval (typename Function< AutoDiff< T > >::FunctionArg x) const
virtual Function< AutoDiff< T > > * | clone () const
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< AutoDiff< T > >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< AutoDiff< T > >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::Gaussian3DParam< AutoDiff< T > >
| Gaussian3DParam ()
| Constructs the three dimensional Gaussians.
Gaussian3DParam< AutoDiff< T > > & | operator= (const Gaussian3DParam< AutoDiff< T > > &other)
| Copy assignment.
virtual | ~Gaussian3DParam ()
| Destructor.
virtual const String & | name () const
| Give name of function.
virtual uInt | ndim () const
| Return dimensionality.
AutoDiff< T > | height () const
| Get or set the peak height of the Gaussian.
void | setHeight (const AutoDiff< T > &height)
AutoDiff< T > | flux () const
| Get or set the total flux of the Gaussian.
void | setFlux (const AutoDiff< T > &flux)
Vector< AutoDiff< T > > | center () const
| Get or cet the center coordinates of the Gaussian.
void | setCenter (const Vector< AutoDiff< T > > &center)
AutoDiff< T > | xCenter () const
void | setXcenter (const AutoDiff< T > &xcenter)
AutoDiff< T > | yCenter () const
void | setYcenter (const AutoDiff< T > &ycenter)
AutoDiff< T > | zCenter () const
void | setZcenter (const AutoDiff< T > &zcenter)
Vector< AutoDiff< T > > | width () const
| Get or set the sigma-width of the Gaussian.
void | setWidth (const Vector< AutoDiff< T > > &width)
void | setXwidth (const AutoDiff< T > &xwidth)
AutoDiff< T > | xWidth () const
void | setYwidth (const AutoDiff< T > &ywidth)
AutoDiff< T > | yWidth () const
void | setZwidth (const AutoDiff< T > &zwidth)
AutoDiff< T > | zWidth () const
AutoDiff< T > | theta () const
| Get or set the rotation angles of the Gaussian.
void | settheta (const AutoDiff< T > &sT)
AutoDiff< T > | phi () const
void | setphi (const AutoDiff< T > &sP)
Public Member Functions inherited from casacore::Function< AutoDiff< T > >
| Function ()
| Constructors.
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual T | eval (FunctionArg x) const=0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
virtual T | operator() () const
| Evaluate this function object at xor at x, y.
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Private Member Functions

T | sq (T v) const

## Additional Inherited Members

Public Types inherited from casacore::Gaussian3DParam< AutoDiff< T > >
enum |
| Parameter handling for the functional for 3D Gaussian Class. More...
Public Types inherited from casacore::Function< AutoDiff< T > >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg
Protected Member Functions inherited from casacore::Gaussian3DParam< AutoDiff< T > >
void | settrigvals () const
Protected Attributes inherited from casacore::Gaussian3DParam< AutoDiff< T > >
AutoDiff< T > | fwhm2int
AutoDiff< T > | stoT_p
AutoDiff< T > | stoP_p
AutoDiff< T > | cosT_p
AutoDiff< T > | sinT_p
AutoDiff< T > | cosP_p
AutoDiff< T > | sinP_p
AutoDiff< T > | cosTcosP_p
AutoDiff< T > | cosTsinP_p
AutoDiff< T > | sinTcosP_p
AutoDiff< T > | sinTsinP_p
Protected Attributes inherited from casacore::Function< AutoDiff< T > >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::Gaussian3D_PS< AutoDiff< T > >

Partial specialization of Gaussian3D for AutoDiff.

### Synopsis

Warning: The name Gaussian3D_PS is only for cxx2html documentation problems; Use Gaussian3D in your code;

Definition at line 229 of file Gaussian3D.h.

## Constructor & Destructor Documentation

## Gaussian3D_PS() [1/5]

template<class T>

casacore::Gaussian3D_PS< AutoDiff< T > >::Gaussian3D_PS | ( |  | ) |

Referenced by Gaussian3D_PS(), Gaussian3D_PS(), and operator=().

## Gaussian3D_PS() [2/5]

template<class T>

casacore::Gaussian3D_PS< AutoDiff< T > >::Gaussian3D_PS | ( | const AutoDiff< T > & | height,
|  | const Vector< AutoDiff< T > > & | center,
|  | const Vector< AutoDiff< T > > & | width,
|  | const AutoDiff< T > & | theta,
|  | const AutoDiff< T > & | phi )

References casacore::Gaussian3DParam< AutoDiff< T > >::center(), casacore::Gaussian3DParam< AutoDiff< T > >::height(), casacore::Gaussian3DParam< AutoDiff< T > >::phi(), casacore::Gaussian3DParam< AutoDiff< T > >::theta(), and casacore::Gaussian3DParam< AutoDiff< T > >::width().

## Gaussian3D_PS() [3/5]

template<class T>

casacore::Gaussian3D_PS< AutoDiff< T > >::Gaussian3D_PS | ( | AutoDiff< T > & | height,
|  | AutoDiff< T > & | xCenter,
|  | AutoDiff< T > & | yCenter,
|  | AutoDiff< T > & | zCenter,
|  | AutoDiff< T > & | xWidth,
|  | AutoDiff< T > & | yWidth,
|  | AutoDiff< T > & | zWidth,
|  | AutoDiff< T > & | theta,
|  | AutoDiff< T > & | phi )

References casacore::Gaussian3DParam< AutoDiff< T > >::height(), casacore::Gaussian3DParam< AutoDiff< T > >::phi(), casacore::Gaussian3DParam< AutoDiff< T > >::theta(), casacore::Gaussian3DParam< AutoDiff< T > >::xCenter(), casacore::Gaussian3DParam< AutoDiff< T > >::xWidth(), casacore::Gaussian3DParam< AutoDiff< T > >::yCenter(), casacore::Gaussian3DParam< AutoDiff< T > >::yWidth(), casacore::Gaussian3DParam< AutoDiff< T > >::zCenter(), and casacore::Gaussian3DParam< AutoDiff< T > >::zWidth().

## Gaussian3D_PS() [4/5]

template<class T>

casacore::Gaussian3D_PS< AutoDiff< T > >::Gaussian3D_PS | ( | const Gaussian3D_PS< AutoDiff< T > > & | other | ) |

References Gaussian3D_PS().

## Gaussian3D_PS() [5/5]

template<class T>
template<class W>

casacore::Gaussian3D_PS< AutoDiff< T > >::Gaussian3D_PS | ( | const Gaussian3D_PS< W > & | other | ) |

inline

Definition at line 245 of file Gaussian3D.h.

References Gaussian3D_PS(), and casacore::Gaussian3DParam< AutoDiff< T > >::Gaussian3DParam().

## ~Gaussian3D_PS()

template<class T>

virtual casacore::Gaussian3D_PS< AutoDiff< T > >::~Gaussian3D_PS | ( |  | ) |

virtual

## Member Function Documentation

## clone()

template<class T>

virtual Function< AutoDiff< T > > * casacore::Gaussian3D_PS< AutoDiff< T > >::clone | ( |  | ) | const

virtual

Return a copy of this object from the heap.

The caller is responsible for deleting this pointer. The cloneAD will return a clone with an AutoDef<T>; the cloneNonAD a clone with <T>. An AipsError will be thrown if the cloneAD() or cloneNonAD() is not implemented for a specific function.

Implements casacore::Function< AutoDiff< T > >.

## cloneAD()

template<class T>

virtual Function< typename FunctionTraits< AutoDiff< T > >::DiffType > * casacore::Gaussian3D_PS< AutoDiff< T > >::cloneAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< AutoDiff< T > >.

Definition at line 254 of file Gaussian3D.h.

## cloneNonAD()

template<class T>

virtual Function< typename FunctionTraits< AutoDiff< T > >::BaseType > * casacore::Gaussian3D_PS< AutoDiff< T > >::cloneNonAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< AutoDiff< T > >.

Definition at line 258 of file Gaussian3D.h.

## eval()

template<class T>

virtual AutoDiff< T > casacore::Gaussian3D_PS< AutoDiff< T > >::eval | ( | typename Function< AutoDiff< T > >::FunctionArg | x | ) | const

virtual

## operator=()

template<class T>

Gaussian3D_PS< AutoDiff< T > > & casacore::Gaussian3D_PS< AutoDiff< T > >::operator= | ( | const Gaussian3D_PS< AutoDiff< T > > & | other | ) |

References Gaussian3D_PS().

## sq()

template<class T>

T casacore::Gaussian3D_PS< AutoDiff< T > >::sq | ( | T | v | ) | const

private

References casacore::Gaussian3DParam< AutoDiff< T > >::AX, casacore::Gaussian3DParam< AutoDiff< T > >::AY, casacore::Gaussian3DParam< AutoDiff< T > >::AZ, casacore::Gaussian3DParam< AutoDiff< T > >::cosP_p, casacore::Gaussian3DParam< AutoDiff< T > >::cosT_p, casacore::Gaussian3DParam< AutoDiff< T > >::cosTcosP_p, casacore::Gaussian3DParam< AutoDiff< T > >::cosTsinP_p, casacore::Gaussian3DParam< AutoDiff< T > >::CX, casacore::Gaussian3DParam< AutoDiff< T > >::CY, casacore::Gaussian3DParam< AutoDiff< T > >::CZ, casacore::Gaussian3DParam< AutoDiff< T > >::fwhm2int, casacore::Gaussian3DParam< AutoDiff< T > >::Gaussian3DParam(), casacore::Gaussian3DParam< AutoDiff< T > >::H, casacore::Function< AutoDiff< T > >::param_p, casacore::Gaussian3DParam< AutoDiff< T > >::PHI, casacore::Gaussian3DParam< AutoDiff< T > >::settrigvals(), casacore::Gaussian3DParam< AutoDiff< T > >::sinP_p, casacore::Gaussian3DParam< AutoDiff< T > >::sinT_p, casacore::Gaussian3DParam< AutoDiff< T > >::sinTcosP_p, casacore::Gaussian3DParam< AutoDiff< T > >::sinTsinP_p, casacore::Gaussian3DParam< AutoDiff< T > >::stoP_p, casacore::Gaussian3DParam< AutoDiff< T > >::stoT_p, and casacore::Gaussian3DParam< AutoDiff< T > >::THETA.

The documentation for this class was generated from the following file:

- scimath/Functionals/Gaussian3D.h